## ros-kinetic-ros-control-boilerplate 0.4.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)
project(ros_control_boilerplate)

# C++ 11
if(NOT "${CMAKE_CXX_STANDARD}")
  set(CMAKE_CXX_STANDARD 11)
endif()
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

find_package(catkin REQUIRED COMPONENTS
  actionlib
  cmake_modules
  control_msgs
  control_toolbox
  controller_manager
  hardware_interface
  joint_limits_interface
  roscpp
  rosparam_shortcuts
  sensor_msgs
  std_msgs
  trajectory_msgs
  transmission_interface
  urdf
)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${PROJECT_SOURCE_DIR}/cmake)
find_package(Gflags REQUIRED)

catkin_package(
  INCLUDE_DIRS
    include
  CATKIN_DEPENDS
    actionlib
    control_msgs
    control_toolbox
    controller_manager
    hardware_interface
    joint_limits_interface
    roscpp
    rosparam_shortcuts
    sensor_msgs
    std_msgs
    trajectory_msgs
    transmission_interface
    urdf
  LIBRARIES
    generic_hw_control_loop
    generic_hw_interface
    sim_hw_interface
)

###########
## Build ##
###########

include_directories(
  include/
  ${catkin_INCLUDE_DIRS}
  ${Gflags_INCLUDE_DIRS}
)

# Control loop
add_library(generic_hw_control_loop
  src/generic_hw_control_loop.cpp
)
target_link_libraries(generic_hw_control_loop
  ${catkin_LIBRARIES}
)

# Generic Hardware Interface
add_library(generic_hw_interface
  src/generic_hw_interface.cpp
)
target_link_libraries(generic_hw_interface
  ${catkin_LIBRARIES}
)

# Simulation Hardware Interface
add_library(sim_hw_interface
  src/sim_hw_interface.cpp
)
target_link_libraries(sim_hw_interface
  generic_hw_interface
  ${catkin_LIBRARIES}
)

# Main control executable
add_executable(${PROJECT_NAME}_sim_hw_main src/sim_hw_main.cpp)
set_target_properties(${PROJECT_NAME}_sim_hw_main PROPERTIES OUTPUT_NAME sim_hw_main PREFIX "")
target_link_libraries(${PROJECT_NAME}_sim_hw_main
  sim_hw_interface
  generic_hw_control_loop
  ${catkin_LIBRARIES}
)

# Test trajectory generator node
add_executable(${PROJECT_NAME}_test_trajectory src/tools/test_trajectory.cpp)
set_target_properties(${PROJECT_NAME}_test_trajectory PROPERTIES OUTPUT_NAME test_trajectory PREFIX "")
target_link_libraries(${PROJECT_NAME}_test_trajectory
  ${catkin_LIBRARIES}
)

## TOOLS ------------------------------------------------------

# Tool for analyzing controller performance
add_library(controller_to_csv src/tools/controller_to_csv.cpp)
target_link_libraries(controller_to_csv
  ${catkin_LIBRARIES}
)
add_executable(${PROJECT_NAME}_controller_to_csv_main src/tools/controller_to_csv_main.cpp)
set_target_properties(${PROJECT_NAME}_controller_to_csv_main PROPERTIES OUTPUT_NAME controller_to_csv_main PREFIX "")
target_link_libraries(${PROJECT_NAME}_controller_to_csv_main
  controller_to_csv
  ${Gflags_LIBRARIES}
  ${catkin_LIBRARIES}
)

# Tool for analyzing controller performance
add_library(csv_to_controller src/tools/csv_to_controller.cpp)
target_link_libraries(csv_to_controller
  ${catkin_LIBRARIES}
)
add_executable(${PROJECT_NAME}_csv_to_controller_main src/tools/csv_to_controller_main.cpp)
set_target_properties(${PROJECT_NAME}_csv_to_controller_main PROPERTIES OUTPUT_NAME csv_to_controller_main PREFIX "")
target_link_libraries(${PROJECT_NAME}_csv_to_controller_main
  csv_to_controller
  ${Gflags_LIBRARIES}
  ${catkin_LIBRARIES}
)

# Tool for controlling a robot from keyboard
add_executable(${PROJECT_NAME}_keyboard_teleop src/tools/keyboard_teleop.cpp)
set_target_properties(${PROJECT_NAME}_keyboard_teleop PROPERTIES OUTPUT_NAME keyboard_teleop PREFIX "")
target_link_libraries(${PROJECT_NAME}_keyboard_teleop
  ${catkin_LIBRARIES}
)

add_subdirectory(rrbot_control)

## Install ------------------------------------------------------------

# Install libraries
install(TARGETS
    controller_to_csv
    csv_to_controller
    generic_hw_control_loop
    generic_hw_interface
    sim_hw_interface
  LIBRARY DESTINATION
    ${CATKIN_PACKAGE_LIB_DESTINATION}
)

# Install executables
install(TARGETS
    ${PROJECT_NAME}_controller_to_csv_main
    ${PROJECT_NAME}_csv_to_controller_main
    ${PROJECT_NAME}_keyboard_teleop
    ${PROJECT_NAME}_sim_hw_main
    ${PROJECT_NAME}_test_trajectory
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)

# Install header files
install(DIRECTORY include/${PROJECT_NAME}/   DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION})

=== debian/changelog ===
ros-kinetic-ros-control-boilerplate (0.4.2-1xenial) xenial; urgency=high

  * Revert "Replaced boost with std shared_ptr"
    This reverts commit d3030f4d383895895931a9ca400497cfb72acdd9. This
    change broke the api, backporting it was an oversight.
  * Add clang-format and catkin_lint checks to CI
    Backported from 638d8acb242813d298d6953d62ba36804b479242
  * CMakeLists reformatting to better match catkin_lint expectations
    Unfortunately we will probably not be able to get catkin_lint to run
    warning-free, as it (correctly) detects that all rrbot_control launch
    files have some extra run dependencies we don't require for building the
    base package.
    Backported from 0db7327c2f14d9a0d3591adf24a82526c6053a37
  * Replaced boost with std shared_ptr
    Backported from 9b46eaf115c16de9e453d59085b75aa9eebc3818
  * Make NodeHandle a const reference
    The classes already make a copy of the NodeHandle so this change only
    make the interface more strict. It should not affect the external
    behavior of this class.
    Backported from 115b9624e60c38f3d5359ab186f00e9b0ae24be3
  * Whitespace cleanup
    Backported from aea83fc71f9a05a24382b673144cc4045b7d8a1b
  * test_trajectory:  Read joints list from trajectory controller params
    If the hardware_interface/joints list contains some joints
    configured in a trajectory controller, the test_trajectory program
    exits with an error:
    [ERROR]: Joints on incoming goal don't match the controller joints.
    [ INFO]: Action finished: REJECTED
    [ INFO]: TestTrajectory Finished
    [ INFO]: Shutting down.
    The correct list of joints for the trajectory controller can be found
    in the <trajectory_controller_name>/joints parameter.
    Since the <trajectory_controller_name>/follow_joint_trajectory
    parameter name is already being passed in, this patch simply shortens
    that to <trajectory_controller_name>, and uses it to construct both
    topic names.  Now the trajectory is generated for the correct number
    of joints.
    Backported from 33daf81d2278a193ab8b5c75e1aaf8c5667ac109
  * Add Robert as maintainer to repo
    Backported from dba8338720bc3b0b2d1ed2c125953ed6d13ae3aa
  * Acknowledge maintainers of this repo in README
    Backported from 5f5fca18cd987e9f6a601ce393bfd47f97758aac
  * Generalize GenericHWControlLoop to all types of RobotHW (#38 <https://github.com/PickNikRobotics/ros_control_boilerplate/issues/38>)
    Backported from 8353dd3f3e4df30bf86269f695769e788227b8ed
  * Update README.md
    Backported from 4e08588ba61e88893a1a6ab7f800144f22cb38a3
  * Fix build badges in README (#37 <https://github.com/PickNikRobotics/ros_control_boilerplate/issues/37>)
    Backported from 66fd47b00b499f4e677fb47ecf8bd848b877f8e0
    There doesn't seem to be any kinetic release for debian, so it is left
    out
    Backported from 66fd47b00b499f4e677fb47ecf8bd848b877f8e0
  * Update .travis.yml to use moveit_ci (#36 <https://github.com/PickNikRobotics/ros_control_boilerplate/issues/36>)
    Backported from 8b50f2142a244a941b576538cf0f44879d5997d9
  * Increase num AsyncSpinners where control loops are instantiated
    Backported from b6a06c856c65698340cb5251531ec0e5ee94aabc
  * Merge pull request #20 <https://github.com/PickNikRobotics/ros_control_boilerplate/issues/20> from ipa-mdl/fix-loop-deadlock
    refactor GenericHWControlLoop to a sleep-based loop
  * Merge pull request #19 <https://github.com/PickNikRobotics/ros_control_boilerplate/issues/19> from PaulBouchier/kinetic-devel
    change sim_control_mode to 0 (position) so demo works
  * Merge pull request #21 <https://github.com/PickNikRobotics/ros_control_boilerplate/issues/21> from MohmadAyman/fix_typo
    fixed a typo in readme
  * fixed a typo in readme
  * refactor GenericHWControlLoop to a sleep-based loop
    using ros:Timer might lead to deadlocks
  * initialize desired_update_period_ (renamed from desired_update_freq_)
  * Revert "Depend on Eigen3"
    This reverts commit 608cc2fd64739ee56c3fbd5a0ae9d5d26b5684d0.
  * change sim_control_mode to 0 (position) so demo works
  * Merge pull request #16 <https://github.com/PickNikRobotics/ros_control_boilerplate/issues/16> from lucasw/xml-version
    xml version tags for all launch files.
  * xml version tags for all launch files.
  * Merge pull request #15 <https://github.com/PickNikRobotics/ros_control_boilerplate/issues/15> from enricotoi/kinetic-devel
    Fixed a typo in the README.md
  * Fixed a typo in the README.md
    rrbot_simulaton.launch -> rrbot_simulation.launch
  * Update README.md
  * Contributors: AndyZe, Dave Coleman, Jafar Abdi, John Morris, Lucas Walter, Mathias Lüdtke, Paul Bouchier, Ramon Wijnands, Robert Wilbrandt, RobertWilbrandt, Tim Übelhör, enrico toivinen, mohmad ayman

 -- Dave Coleman <davetcoleman@gmail.com>  Mon, 22 Feb 2021 21:00:00 -0000

ros-kinetic-ros-control-boilerplate (0.4.1-1xenial) xenial; urgency=high

  * Changed boost::shared_ptr to typedef for Lunar support
  * Implemented simulated velocity control
  * Contributors: Dave Coleman

 -- Dave Coleman <davetcoleman@gmail.com>  Mon, 19 Jun 2017 21:00:00 -0000

ros-kinetic-ros-control-boilerplate (0.4.0-1xenial) xenial; urgency=high

  * Depend on Eigen3
  * Remove dependency on meta package
  * Fixed var name
  * Contributors: Dave Coleman

 -- Dave Coleman <davetcoleman@gmail.com>  Tue, 28 Jun 2016 21:00:00 -0000

ros-kinetic-ros-control-boilerplate (0.3.1-1xenial) xenial; urgency=high

  * API deprecation fix for rosparam_shortcuts
  * Switched to better use of rosparam_shortcuts
  * Ability to record all controller status data, not just at certain frequency
  * Contributors: Dave Coleman

 -- Dave Coleman <davetcoleman@gmail.com>  Tue, 12 Jan 2016 22:00:00 -0000

ros-kinetic-ros-control-boilerplate (0.3.0-1xenial) xenial; urgency=high

  * Removed bad reference name
  * Switched to using name_
  * Record error data
  * Disable soft joint limits
  * header to debug output


=== debian/control ===
Source: ros-kinetic-ros-control-boilerplate
Section: misc
Priority: optional
Maintainer: Dave Coleman <davetcoleman@gmail.com>
Build-Depends: debhelper (>= 9.0.0), libgflags-dev, ros-kinetic-actionlib, ros-kinetic-catkin, ros-kinetic-cmake-modules, ros-kinetic-control-msgs, ros-kinetic-control-toolbox, ros-kinetic-controller-manager, ros-kinetic-hardware-interface, ros-kinetic-joint-limits-interface, ros-kinetic-roscpp, ros-kinetic-rosparam-shortcuts, ros-kinetic-sensor-msgs, ros-kinetic-std-msgs, ros-kinetic-trajectory-msgs, ros-kinetic-transmission-interface, ros-kinetic-urdf
Homepage: https://github.com/davetcoleman/ros_control_boilerplate
Standards-Version: 3.9.2

Package: ros-kinetic-ros-control-boilerplate
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-kinetic-actionlib, ros-kinetic-control-msgs, ros-kinetic-control-toolbox, ros-kinetic-controller-manager, ros-kinetic-hardware-interface, ros-kinetic-joint-limits-interface, ros-kinetic-roscpp, ros-kinetic-rosparam-shortcuts, ros-kinetic-sensor-msgs, ros-kinetic-std-msgs, ros-kinetic-trajectory-msgs, ros-kinetic-transmission-interface, ros-kinetic-urdf
Description: Simple simulation interface and template for setting up a hardware interface for ros_control

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/kinetic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/kinetic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/kinetic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-kinetic-ros-control-boilerplate//opt/ros/kinetic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_install
